<?php

namespace Lean\Api\Form;

use CSSLSJ\ExamenFga\Api\{Lib};
use Picea\Ui\Method\{FormContextInterface};
use Ulmus\Entity\EntityInterface;

class Delete implements \Picea\Ui\Method\FormInterface {

    public function __construct(
        public EntityInterface $entity,
    ) {}

    public function getEntity() : EntityInterface
    {
        return $this->entity;
    }

    public function initialize(FormContextInterface $context) : void {}

    public function validate(FormContextInterface $context) : bool
    {
        return $context->valid();
    }

    public function execute(FormContextInterface $context) : void
    {
        try {
            if ( $this->getEntity()::repository()->destroy($this->getEntity()) ) {
                $context->pushMessage(Lib\Message::generateSuccess(
                    "Suppression effectué avec succès"
                ));
            }
            else {
                throw new \InvalidArgumentException("Suppression impossible; une erreur semble survenue...");
            }
        }
        catch(\Throwable $ex) {
            throw new \ErrorException(sprintf("Une erreur est survenue : '%s'", $ex->getMessage()));
        }
    }
}
